#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void compValue2(double FX[],double FY[],double nsx[],double nsy[],double npx[],double npy[],double CSMX[],double CSMY[],
				double x[],double value[],double LMX[],double LMY[],double MX[],double MY[],double t,
				double MCSMX[],double MCSMY[],struct geo_data geo)
{
	int i,q,r = 0;
	int ti,tj,tk;

	//-----------------CSM----------------------
	for(q=0;q<node_Num;q++)	
	{
		//ʍSp(xCyƂɌŒ)
		CSMX[q] = 2*omega*nsx[q]+(omega*omega)*npx[q];	//2**Vn+^2*Un
		CSMY[q] = 2*omega*nsy[q]+(omega*omega)*npy[q];
	}
	//-------------------------------------------

	//eOp`̊švZ(lumped inertia matrix)-------------------
	//runge-kuttȃOłłH
	for(i=0;i<tri_Num;i++)
	{
		ti = geo.triangle[i].point_i;
		tj = geo.triangle[i].point_j;
		tk = geo.triangle[i].point_k;

		MX[ti]	+= (D*h*geo.triangle[i].area)/3.0;
		MY[ti]	+= (D*h*geo.triangle[i].area)/3.0;
		MX[tj]	+= (D*h*geo.triangle[i].area)/3.0;
		MY[tj]	+= (D*h*geo.triangle[i].area)/3.0;
		MX[tk]	+= (D*h*geo.triangle[i].area)/3.0;
		MY[tk]	+= (D*h*geo.triangle[i].area)/3.0;
	}
	//--------------------------------------------------------------------

	//S͌vZ(ӂ̂)---------------------------
	for(q=0;q<wide+1;q++)
	{
		LMX[q] = FX[q]-(1.0/MX[q])*CSMX[q];
		LMY[q] = FY[q]-(1.0/MY[q])*CSMY[q];
	}
	for(q=0;q<wide+1;q++)
	{
		value[2*q+(8*node_Num)]		= LMX[q];
		value[2*q+(8*node_Num+1)]	= LMY[q];
	}
	//-----------------------------------------------

	//------d/dt(u)=	m[h̑x----------
	for(q=0;q<node_Num*2;q++)
	{
		value[q] = x[q+(2*node_Num)];
	}
	//----------------------------------------

	//d/dt(v)=	m[h̉x----------------
	for(q=0;q<node_Num;q++)
	{
		value[(q*2)+2*node_Num]		= (1.0/MX[q])*(-FX[q]);
		value[(q*2+1)+2*node_Num]	= (1.0/MY[q])*(-FY[q]);
	}
	//----------------------------------------

	//-----ʂSɌŒ(x,yɓȂ)Ăꍇ-----
	for(q=0;q<=wide;q++)
	{
		value[(q*2)+2*node_Num]		= -CSMX[q];			//xŒ(Œ肵Ȃꍇ̓RgAEgĂ)
		value[(q*2+1)+2*node_Num]	= -CSMY[q];			//yŒ
	}
	//-------------------------------------------------------------
}
