#include <GL/glut.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h> /* exit() ̂ */
#include "data.h"
#include "structdata.h"

FILE *fp,*fg,*ft;
static bool node = true;
static bool edge = true;
static bool reset = false;
static bool stop = false;

static GLdouble scale	= 0.03;

//ʍĕ\
void idle(void)
{
  glutPostRedisplay();
}

//^C}֐
void timer(int value) {
	glutPostRedisplay();
	glutTimerFunc(100 , timer , 0);
}

//`
void display(void)
{
	int i,j,k,q;
	static struct geo_data geo;

	double t;
	double dt;
	double ux[node_Num*4];
	double uy[node_Num*4];
	double LMX[wide+1];
	double LMY[wide+1];

	//`̍ۂ͕sv
#if 1
	//t@Cf[^擾
	fscanf(fp,"%lf",&t);
	fscanf(fp,"%lf",&dt);

	for(q=0;q<node_Num*4;q++)
	{
		fscanf(fp,"%lf%lf",&ux[q],&uy[q]);
	}
	for(q=0;q<wide+1;q++)
	{
		fscanf(fp,"%lf%lf",&LMX[q],&LMY[q]);
	}

	printf("Progress:  Virtual:%lf[s]\r",t);

	//t@C̍Ō܂œǂݍނV~[VԂo߂瓪ĕ\
	if(t < EOF || (int)t == (int)sim_time || reset == true)
	{
		glutIdleFunc(0);
		fclose(fp);
		printf("PRESS MOUSE BUTTON ON DISPLAY\r");
		if((fp = fopen("result.dat","r"))==NULL)
		{
			printf("file cannot open.\n");
		}
		if(reset == true)
		{
			reset = false;
			glutPostRedisplay();
		}
	}
#endif
	//܂
	
	//bV
	for(i=0;i<(wide+1)*(height+1);i++)
	{
		fscanf(fg,"%d%lf%lf",&j,&geo.point[i].x,&geo.point[i].y);
	}

	for(i=0;i<wide*height*2;i++)
	{
		fscanf(ft,"%d%d%d%d",&k,&geo.triangle[i].point_i,&geo.triangle[i].point_j,&geo.triangle[i].point_k);
	}

	//\
	glClear(GL_COLOR_BUFFER_BIT);

	//\
	glBegin(GL_LINES);
	glColor3d(0.0, 0.0, 0.0);
	glVertex2f(-((wide*tri_wide/2)+tri_wide)/scale,-(height*tri_height/2)/scale);
	glVertex2f(((wide*tri_wide/2)+tri_wide)/scale,-(height*tri_height/2)/scale);
	glEnd();


	if(node == true)
	{
		//iq_\
		glPointSize(4);
 		glBegin(GL_POINTS); 
		for(i=0;i<node_Num;i++)
		{
			glVertex2f(((geo.point[i].x+ux[i])-(wide*tri_wide/2))/scale, ((geo.point[i].y+uy[i])-(height*tri_height/2))/scale);
		}
		glEnd();
	}
	
	if(edge == true)
	{
		//Ő\
		for(i=0;i<tri_Num;i++)
		{
			int point_i = geo.triangle[i].point_i;
			int point_j = geo.triangle[i].point_j;
			int point_k = geo.triangle[i].point_k;

			glBegin(GL_LINE_LOOP);
			glVertex2d(((geo.point[point_i].x+ux[point_i])-(wide*tri_wide/2))/scale, ((geo.point[point_i].y+uy[point_i])-(height*tri_height/2))/scale);
			glVertex2d(((geo.point[point_j].x+ux[point_j])-(wide*tri_wide/2))/scale, ((geo.point[point_j].y+uy[point_j])-(height*tri_height/2))/scale);
			glVertex2d(((geo.point[point_k].x+ux[point_k])-(wide*tri_wide/2))/scale, ((geo.point[point_k].y+uy[point_k])-(height*tri_height/2))/scale);
			glEnd();
		}
	}

	// `;
	char text[256];
	glRasterPos3d(-(((wide*tri_wide/2)+tri_wide))/scale, -((height*tri_height/2)+tri_height*1.5)/scale, 0.0); // `ʒu
	sprintf(text,"Progress :  Virtual:%lf[s]",t);
	for(i=0; i<(int)strlen( text ); i++ )
	{
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18,text[i]);
	}
//	drawBitmapString(GLUT_BITMAP_HELVETICA_18,"time");

	//oߎԕ\
	//box
	glBegin(GL_LINE_LOOP);
	glPushMatrix();
	glColor3d(0.0, 1.0, 0.5);
	glVertex2d(-((wide*tri_wide/2)+tri_wide)/scale, -((height*tri_height/2)+tri_height*2)/scale);
	glVertex2d( ((wide*tri_wide/2)+tri_wide)/scale, -((height*tri_height/2)+tri_height*2)/scale);
	glVertex2d( ((wide*tri_wide/2)+tri_wide)/scale, -((height*tri_height/2)+tri_height*3)/scale);
	glVertex2d(-((wide*tri_wide/2)+tri_wide)/scale, -((height*tri_height/2)+tri_height*3)/scale);
	glPopMatrix();
	glEnd();
	//time bar
	glBegin(GL_QUADS);
	glPushMatrix();
	glColor3d(0.0, 1.0, 0.5);
	glVertex2d(-((wide*tri_wide/2)+tri_wide)/scale,									-((height*tri_height/2)+tri_height*2)/scale);
	glVertex2d(-(((wide*tri_wide/2)+tri_wide)*(1-t/((double)sim_time/2)))/scale,	-((height*tri_height/2)+tri_height*2)/scale);
	glVertex2d(-(((wide*tri_wide/2)+tri_wide)*(1-t/((double)sim_time/2)))/scale,	-((height*tri_height/2)+tri_height*3)/scale);
	glVertex2d(-((wide*tri_wide/2)+tri_wide)/scale,									-((height*tri_height/2)+tri_height*3)/scale);
	glPopMatrix();
	glEnd();

	glutSwapBuffers();
}

void resize(int w, int h)
{
	/* EBhEŜr[|[gɂ */
	glViewport(0, 0, w, h);

	/* ϊs̏ */
	glLoadIdentity();

	/* XN[̕\̈r[|[g̑傫ɔႳ */
	glOrtho(-w / 200.0, w / 200.0, -h / 200.0, h / 200.0, -1.0, 1.0);
}

void mouse(int button, int state, int x, int y)
{
	switch (button) {
	case GLUT_LEFT_BUTTON:
		glutIdleFunc(idle);
		break;
	case GLUT_RIGHT_BUTTON:
		if (state == GLUT_DOWN) {
			/* Aj[VJn */
			glutIdleFunc(idle);
		}
    else {
		/* Aj[V~ */
		glutIdleFunc(0);
    }
		break;
	case GLUT_MIDDLE_BUTTON:
		if (state == GLUT_DOWN) {
			/* R} (PXebvi߂) */
			glutPostRedisplay();
		}
		break;
	default:
		break;
	}
}
  
/* L[{[hvOIݒ */
void keyboard(unsigned char key, int x, int y)
{
	switch (key) {
	//ESCqL[ŃvOI
	case '\33': /* \33  ESC  ASCII R[h (8iŕ\j*/
	case 'q':
		exit(0);
	case 'n':
		if(node==true){
			node = false;
			glutPostRedisplay();
		}
		else{
			node = true;
			glutPostRedisplay();
		}
		break;
	case 'e':
		if(edge==true){
			edge = false;
			glutPostRedisplay();
		}
		else{
			edge = true;
			glutPostRedisplay();
		}
		break;
	case 's':
		if(stop==true){
			stop = false;
			glutIdleFunc(idle);
		}
		else{
			stop = true;
			glutIdleFunc(0);
		}
		break;
	case 'r':
		if(reset==true){
			reset = false;
//			glutPostRedisplay();
		}
		else{
			reset = true;
//			glutPostRedisplay();
		}
		break;
	default :
		break;
	}
}

void specialkey(int key, int x, int y)
{
	switch (key) {
	case GLUT_KEY_DOWN:
		//printf("%d %d\n",x,y);
		scale += 0.0025;
		glutPostRedisplay();
		break;
	case GLUT_KEY_UP:
		//printf("%d %d\n",x,y);
		scale -= 0.0025;
		glutPostRedisplay();
		break;
	default:
		break;
	}
}

void init(void)
{
	glClearColor(1.0, 1.0, 1.0, 1.0);
}

int main(int argc, char** argv)
{
	if((fp = fopen("result.dat","r"))==NULL)
	{
		printf("file cannot open.\n");
	}

	if((fg = fopen("geodata.dat","r"))==NULL)
	{
		printf("file cannot open.\n");
	}

	if((ft = fopen("tridata.dat","r"))==NULL)
	{
		printf("file cannot open.\n");
	}

	printf("press Enter to start \n");
	getchar();

	/*  */
	glutInit(&argc, argv);

	/* EBhE̐ */
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
	glutInitWindowPosition(200, 50); /* EBḧʒu(x, y) */
	glutInitWindowSize(300, 300); /* EBh̑傫(w, h) */
	glutCreateWindow(argv[0]);
	glutReshapeFunc(resize);


	/* OpenGL [`̌ďo */
	init();

	/* `惋[`̐ݒ */
	glutDisplayFunc(display);

	/* ͏[`̐ݒ */
	glutMouseFunc(mouse);
	glutKeyboardFunc( keyboard );
	glutSpecialFunc( specialkey );
	
	//openGL̎ԕ\p
//	glutTimerFunc(100 , timer , 0);

	/* [v */
	glutMainLoop();
	return 0;
}